# Changelog
All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](http://keepachangelog.com/en/1.0.0/)
and this project adheres to [Semantic Versioning](http://semver.org/spec/v2.0.0.html).

## [Unreleased]

## [7.1.2] - 2022-09-27

### Changed

- Bumped dependencies, in PR [#196](https://github.com/compulim/web-speech-cognitive-services/pull/196)
   -  Production dependencies
      -  [`@babel/runtime@7.19.0`](https://npmjs.com/package/@babel/runtime)
      -  [`base64-arraybuffer@1.0.2`](https://npmjs.com/package/base64-arraybuffer)
      -  [`memoize-one@6.0.0`](https://npmjs.com/package/memoize-one)
      -  [`p-defer-es5@2.0.1`](https://npmjs.com/package/p-defer-es5)
   -  Development dependencies
      -  [`@babel/cli@7.18.10`](https://npmjs.com/package/@babel/cli)
      -  [`@babel/core@7.19.1`](https://npmjs.com/package/@babel/core)
      -  [`@babel/plugin-proposal-object-rest-spread@7.18.9`](https://npmjs.com/package/@babel/plugin-proposal-object-rest-spread)
      -  [`@babel/plugin-transform-runtime@7.19.1`](https://npmjs.com/package/@babel/plugin-transform-runtime)
      -  [`@babel/preset-env@7.19.1`](https://npmjs.com/package/@babel/preset-env)
      -  [`@babel/preset-react@7.18.6`](https://npmjs.com/package/@babel/preset-react)
      -  [`babel-jest@29.0.3`](https://npmjs.com/package/babel-jest)
      -  [`babel-plugin-transform-inline-environment-variables@0.4.4`](https://npmjs.com/package/babel-plugin-transform-inline-environment-variables)
      -  [`classnames@2.3.2`](https://npmjs.com/package/classnames)
      -  [`concurrently@7.4.0`](https://npmjs.com/package/concurrently)
      -  [`dotenv@16.0.2`](https://npmjs.com/package/dotenv)
      -  [`eslint@8.24.0`](https://npmjs.com/package/eslint)
      -  [`global-agent@3.0.0`](https://npmjs.com/package/global-agent)
      -  [`jest@29.0.3`](https://npmjs.com/package/jest)
      -  [`microsoft-cognitiveservices-speech-sdk@1.23.0`](https://npmjs.com/package/microsoft-cognitiveservices-speech-sdk)
      -  [`node-fetch@2.6.7`](https://npmjs.com/package/node-fetch)
      -  [`p-defer-es5@2.0.1`](https://npmjs.com/package/p-defer-es5)
      -  [`prettier@2.7.1`](https://npmjs.com/package/prettier)
      -  [`react-dom@18.2.0`](https://npmjs.com/package/react-dom)
      -  [`react-redux@8.0.4`](https://npmjs.com/package/react-redux)
      -  [`react-say@2.1.0`](https://npmjs.com/package/react-say)
      -  [`react-scripts@5.0.1`](https://npmjs.com/package/react-scripts)
      -  [`react@18.2.0`](https://npmjs.com/package/react)
      -  [`redux-saga@1.2.1`](https://npmjs.com/package/redux-saga)
      -  [`redux@4.2.0`](https://npmjs.com/package/redux)
      -  [`webpack-cli@4.10.0`](https://npmjs.com/package/webpack-cli)
      -  [`webpack-stats-plugin@1.1.0`](https://npmjs.com/package/webpack-stats-plugin)
      -  [`webpack@5.74.0`](https://npmjs.com/package/webpack)

## [7.1.1] - 2021-07-20

### Changed

- Bumped dependencies, in PR [#151](https://github.com/compulim/web-speech-cognitive-services/pull/151), PR [#152](https://github.com/compulim/web-speech-cognitive-services/pull/152) and PR [#153](https://github.com/compulim/web-speech-cognitive-services/pull/153)
   - [`@babel/cli@7.14.5`](https://npmjs.com/package/@babel/cli)
   - [`@babel/core@7.14.6`](https://npmjs.com/package/@babel/core)
   - [`@babel/plugin-proposal-object-rest-spread@7.14.7`](https://npmjs.com/package/@babel/plugin-proposal-object-rest-spread)
   - [`@babel/plugin-transform-runtime@7.14.5`](https://npmjs.com/package/@babel/plugin-transform-runtime)
   - [`@babel/preset-env@7.14.7`](https://npmjs.com/package/@babel/preset-env)
   - [`@babel/preset-react@7.14.5`](https://npmjs.com/package/@babel/preset-react)
   - [`@babel/runtime@7.14.6`](https://npmjs.com/package/@babel/runtime)
   - [`babel-jest@27.0.6`](https://npmjs.com/package/babel-jest)
   - [`classnames@2.3.1`](https://npmjs.com/package/classnames)
   - [`concurrently@6.2.0`](https://npmjs.com/package/concurrently)
   - [`dotenv@10.0.0`](https://npmjs.com/package/dotenv)
   - [`eslint@7.30.0`](https://npmjs.com/package/eslint)
   - [`event-target-shim@6.0.2`](https://npmjs.com/package/event-target-shim)
   - [`global-agent@2.2.0`](https://npmjs.com/package/global-agent)
   - [`jest@27.0.6`](https://npmjs.com/package/jest)
   - [`lerna@4.0.0`](https://npmjs.com/package/lerna)
   - [`memoize-one@5.2.1`](https://npmjs.com/package/memoize-one)
   - [`microsoft-cognitiveservices-speech-sdk@1.17.0`](https://npmjs.com/package/microsoft-cognitiveservices-speech-sdk)
   - [`p-defer-es5@2.0.0`](https://npmjs.com/package/p-defer-es5)
   - [`p-defer@4.0.0`](https://npmjs.com/package/p-defer)
   - [`prettier@2.3.2`](https://npmjs.com/package/prettier)
   - [`react-dictate-button@2.0.1`](https://npmjs.com/package/react-dictate-button)
   - [`react-dom@17.0.2`](https://npmjs.com/package/react-dom)
   - [`react-redux@7.2.4`](https://npmjs.com/package/react-redux)
   - [`react-scripts@4.0.3`](https://npmjs.com/package/react-scripts)
   - [`react@17.0.2`](https://npmjs.com/package/react)
   - [`redux@4.1.0`](https://npmjs.com/package/redux)
   - [`webpack-cli@4.7.2`](https://npmjs.com/package/webpack-cli)
   - [`webpack-stats-plugin@1.0.3`](https://npmjs.com/package/webpack-stats-plugin)
   - [`webpack@5.44.0`](https://npmjs.com/package/webpack)

## [7.1.0] - 2021-02-01

### Changed

- Moved from [`webpack-visualizer-plugin`](https://npmjs.com/package/webpack-visualizer-plugin) to [`webpack-stats-plugin`](https://npmjs.com/package/webpack-stats-plugin)
- Bumped production dependencies
   - [`@babel/runtime@7.12.5`](https://npmjs.com/package/@babel/runtime)
   - [`event-target-shim@6.0.2`](https://npmjs.com/package/event-target-shim)
- Bumped development dependencies
   - [`@babel/cli@7.12.10`](https://npmjs.com/package/@babel/cli)
   - [`@babel/core@7.12.10`](https://npmjs.com/package/@babel/core)
   - [`@babel/plugin-proposal-object-rest-spread@7.12.1`](https://npmjs.com/package/@babel/plugin-proposal-object-rest-spread)
   - [`@babel/plugin-transform-runtime@7.12.10`](https://npmjs.com/package/@babel/plugin-transform-runtime)
   - [`@babel/preset-env@7.12.11`](https://npmjs.com/package/@babel/preset-env)
   - [`babel-jest@26.6.3`](https://npmjs.com/package/babel-jest)
   - [`eslint@7.18.0`](https://npmjs.com/package/eslint)
   - [`global-agent@2.1.12`](https://npmjs.com/package/global-agent)
   - [`jest@26.6.3`](https://npmjs.com/package/jest)
   - [`microsoft-cognitiveservices-speech-sdk@1.15.0`](https://npmjs.com/package/microsoft-cognitiveservices-speech-sdk)
   - [`node-fetch@2.6.1`](https://npmjs.com/package/node-fetch)
   - [`p-defer-es5@1.2.1`](https://npm.js.com/package/p-defer-es5)
   - [`prettier@2.2.1`](https://npmjs.com/package/prettier)
   - [`react-dom@17.0.1`](https://npm.js.com/package/react-dom)
   - [`react-redux@7.2.2`](https://npm.js.com/package/react-redux)
   - [`react-say@2.0.1`](https://npm.js.com/package/react-say)
   - [`react-scripts@4.0.1`](https://npm.js.com/package/react-scripts)
   - [`react@17.0.1`](https://npm.js.com/package/react)
   - [`simple-update-in@2.2.0`](https://npm.js.com/package/simple-update-in)

## [7.0.1] - 2020-08-06

### Changed

- Bumped dependencies
   - [`event-target-shim-es5@1.2.0`](https://npmjs.com/package/event-target-shim-es5)
   - [`p-defer-es5@1.2.1`](https://npmjs.com/package/p-defer-es5)

## [7.0.0] - 2020-05-27

### Breaking changes

- To enable developers to select their version of Cognitive Services Speech SDK and use newer features, we are moving [`microsoft-cognitiveservices-speech-sdk`](https://npmjs.com/package/microsoft-cognitiveservices-speech-sdk) to `peerDependencies`.
   - When you install `web-speech-cognitive-services`, you will also need to install a compatible version of `microsoft-cognitiveservices-speech-sdk`.

### Changed

- Fixes [#96](https://github.com/compulim/web-speech-cognitive-services/issues/96), move [`microsoft-cognitiveservices-speech-sdk`](https://npmjs.com/package/microsoft-cognitive-services-speech-sdk) to `peerDependencies`, by [@compulim](https://github.com/compulim), in PR [#97](https://github.com/compulim/web-speech-cognitive-services/pull/97)

## [6.3.0] - 2020-03-28

### Changed

- Debumped [`microsoft-cognitiveservices-speech-sdk@1.9.1`](https://npmjs.com/package/microsoft-cognitiveservices-speech-sdk), by [@compulim](https://github.com/compulim) in PR [#94](https://github.com/compulim/web-speech-cognitive-services/pull/94)

## [6.2.0] - 2020-03-27

### Breaking changes

- Temporarily reverting breaking changes by reintroducing Bing Speech and `fetchAuthorizationToken`, by [@compulim](https://github.com/compulim) in PR [#92](https://github.com/compulim/web-speech-cognitive-services/pull/92).

## [6.1.0] - 2020-03-26

### Breaking changes

- ~As Bing Speech has deprecated and removed from Azure. Bing Speech support has been removed.~
- ~`fetchAuthorizationToken` is removed, please refer to [this documentation on how to get an access token](https://docs.microsoft.com/en-us/azure/cognitive-services/speech-service/rest-speech-to-text#how-to-get-an-access-token).~

### Added

- Resolves [#88](https://github.com/compulim/web-speech-cognitive-services/issues/88). Support sovereign cloud, by [@compulim](https://github.com/compulim) in PR [#89](https://github.com/compulim/web-speech-cognitive-services/pull/89)

### Removed

- ~Bing Speech support is removed, by [@compulim](https://github.com/compulim), in PR [#87](https://github.com/compulim/web-speech-cognitive-services/pull/87).~
- ~`fetchAuthorizationToken` is removed, by [@compulim](https://github.com/compulim), in PR [#89](https://github.com/compulim/web-speech-cognitive-services/pull/89).~

### Changed

- Bumped dependencies, in PR [#87](https://github.com/compulim/web-speech-cognitive-services/pull/87), by [@compulim](https://github.com/compulim)
   - Production dependencies
      - [`@babel/runtime@7.8.7`](https://npmjs.com/package/@babel/runtime)
      - [`event-target-shim-es5@1.0.1`](https://npmjs.com/package/event-target-shim-es5)
      - [`event-target-shim@5.0.1`](https://npmjs.com/package/event-target-shim)
      - [`memoize-one@5.1.1`](https://npmjs.com/package/memoize-one)
      - [`microsoft-cognitiveservices-speech-sdk@1.10.1`](https://npmjs.com/package/microsoft-cognitiveservices-speech-sdk)
      - [`simple-update-in@2.1.1`](https://npmjs.com/package/simple-update-in)
   - Development dependencies
      - [`@babel/cli@7.8.4`](https://npmjs.com/package/@babel/cli)
      - [`@babel/core@7.8.7`](https://npmjs.com/package/@babel/core)
      - [`@babel/plugin-proposal-object-rest-spread@7.8.3`](https://npmjs.com/package/@babel/plugin-proposal-object-rest-spread)
      - [`@babel/plugin-transform-runtime@7.8.3`](https://npmjs.com/package/@babel/plugin-transform-runtime)
      - [`@babel/preset-env@7.8.7`](https://npmjs.com/package/@babel/preset-env)
      - [`@babel/preset-react@7.8.3`](https://npmjs.com/package/@babel/preset-react)
      - [`@lerna@3.20.2`](https://npmjs.com/package/@lerna)
      - [`babel-jest@25.1.0`](https://npmjs.com/package/babel-jest)
      - [`concurrently@4.1.2`](https://npmjs.com/package/concurrently)
      - [`eslint@6.8.0`](https://npmjs.com/package/eslint)
      - [`jest@25.1.0`](https://npmjs.com/package/jest)
      - [`lolex@5.1.2`](https://npmjs.com/package/lolex)
      - [`webpack-cli@3.3.11`](https://npmjs.com/package/webpack-cli)
      - [`webpack@4.42.0`](https://npmjs.com/package/webpack)
- Use [`p-defer-es5`](https://npmjs.com/package/p-defer-es5) instead of adopted `createDeferred.js`, in PR [#89](https://github.com/compulim/web-speech-cognitive-services/pull/89).

## [6.0.0] - 2019-12-03

### Breaking changes

#### Unifying options to pass credentials

`authorizationToken`, `region`, and `subscriptionKey` are being deprecated in favor of `credentials` options. `credentials` can be one of the following types:

- `{ authorizationToken: string, region: string? }`
- `{ region: string?, subscriptionKey: string }`
- `Promise<{ authorizationToken: string, region: string? }>`
- `Promise<{ region: string?, subscriptionKey: string }>`
- `() => { authorizationToken: string, region: string? }`
- `() => { region: string?, subscriptionKey: string }`
- `() => Promise<{ authorizationToken: string, region: string? }>`
- `() => Promise<{ region: string?, subscriptionKey: string }>`

If `credentials` is a function, it will be called just before the credentials is needed and may be called very frequently. This behavior matches the deprecating `authorizationToken`. The result of the call is also expected to be cached.

If `region` is not returned, the default value of `"westus"` will be used.

### Fixed

- Speech recognition: Removed extraneous finalized `result` event in continuous mode, by [@compulim](https://github.com/compulim), in PR [#79](https://github.com/compulim/web-speech-cognitive-services/pull/79)

### Removed

- 🔥 `authorizationToken`, `region`, and `subscriptionKey` are being deprecated in favor of `credentials` options, by [@compulim](https://github.com/compulim) in PR [#80](https://github.com/compulim/web-speech-cognitive-services/pull/80)

### Added

- `playground`: Add delayed start to playground for testing speech recognition initiated outside of user gestures, in PR [#78](https://github.com/compulim/web-speech-congitive-services/pull/78)
- Speech recognition: New `looseEvents` option, default is `false`. When enabled, we will no longer follow observed browser event order. We will send finalized `result` event as early as possible. This will not break conformance to W3C specifications. By [@compulim](https://github.com/compulim), in PR [#79](https://github.com/compulim/web-speech-cognitive-services/pull/79)
- Speech recognition: Create ponyfill using `SpeechRecognizer` object from [`microsoft-cognitiveservices-speech-sdk`](https://npmjs.com/package/microsoft-cognitiveservices-speech-sdk), by [@compulim](https://github.com/compulim), in PR [#73](https://github.com/compulim/web-speech-cognitive-services/pull/73)
- `credentials` option is added for obtaining authorization token and region, or subscription key and region, in a single object or function call, by [@compulim](https://github.com/compulim) in PR [#80](https://github.com/compulim/web-speech-cognitive-services/pull/80)
- Speech recognition: Polyfill will have `abort`/`stop` function set to `undefined` if the underlying recognizer from Cognitive Services SDK does not support stop/abort, in PR [#81](https://github.com/compulim/web-speech-cognitive-services/pull/81)

### Changed

- Bumped dependencies, in PR [#73](https://github.com/compulim/web-speech-cognitive-services/pull/73)
   - [babel-jest@^24.9.0](https://www.npmjs.com/package/babel-jest)
   - [jest@^24.9.0](https://www.npmjs.com/package/jest)
   - [rimraf@^3.0.0](https://www.npmjs.com/package/rimraf)

## [5.0.1] - 2019-10-25

### Changed

- Fixed dependences in PR [#76](https://github.com/compulim/web-speech-cognitive-services/pull/76)
   - `bundle` package
      - `dependencies`: Moved `eslint` to development dependencies
   - `component` package
      - `peerDependencies`: No longer requires `react`
      - `dependencies`
         - Moved `eslint` to development dependencies
         - Removed `event-target-shim` because incompatibility with ES5
      - `devDependencies`: Removed `react`
   - Removed `import '@babel/runtime'` explicitly

## [5.0.0] - 2019-10-23

### Breaking changes

- Instead of stopping `AudioContext` after all pending utterances are finished, the `AudioContext` is now persisted. If this is not desirable in your application and would like to control the lifetime of `AudioContext` object, please create your own instance and pass it as an option named `audioContext` when creating the ponyfill
- `createSpeechServicesPonyfill` function is no longer asynchronous
   - Immediate after the ponyfill is created, we will fetch voice list from the services and emit `voiceschanged` event on completion

### Added

- Speech recognition: Fix [#23](https://github.com/compulim/web-speech-cognitive-services/issues/23) and [#24](https://github.com/compulim/web-speech-cognitive-services/issues/24), support `audiostart`/`audioend`/`soundstart`/`soundend` event, in PR [#33](https://github.com/compulim/web-speech-cognitive-services/pull/33)
- Speech recognition: Fix [#25](https://github.com/compulim/web-speech-cognitive-services/issues/25) and [#26](https://github.com/compulim/web-speech-cognitive-services/issues/26), support true `abort` and `stop` function, in PR [#33](https://github.com/compulim/web-speech-cognitive-services/pull/33)
- Speech recognition: Fix [#29](https://github.com/compulim/web-speech-cognitive-services/issues/29), support continuous mode, in PR [#33](https://github.com/compulim/web-speech-cognitive-services/pull/33)
   - Quirks: in continuous mode, calling `stop` in-between `recognizing` and `recognized` will not emit final `result` event
- Speech recognition: New `audioConfig` option to override the default `AudioConfig.fromDefaultMicrophoneInput`, in PR [#33](https://github.com/compulim/web-speech-cognitive-services/pull/33)
- Speech synthesis: Fix [#32](https://github.com/compulim/web-speech-cognitive-services/issues/32), fetch voices from services, in PR [#35](https://github.com/compulim/web-speech-cognitive-services/pull/35)
- Speech synthesis: Fix [#34](https://github.com/compulim/web-speech-cognitive-services/issues/34), in PR [#36](https://github.com/compulim/web-speech-cognitive-services/pull/36) and PR [#44](https://github.com/compulim/web-speech-cognitive-services/pull/44)
   - Support user-controlled `AudioContext` object to be passed as an option named `audioContext`
   - If no `audioContext` option is passed, will create a new `AudioContext` object on first synthesis
- Speech synthesis: If an empty utterance is being synthesized, will play an local empty audio clip, in PR [#36](https://github.com/compulim/web-speech-cognitive-services/pull/36)
- Speech recognition: Fix [#30](https://github.com/compulim/web-speech-cognitive-services/issues/30), support dynamic phrases, in PR [#37](https://github.com/compulim/web-speech-cognitive-services/pull/37)
   - Pass it as an array to `SpeechRecognition.grammars.phrases`
- Speech recognition: Fix [#31](https://github.com/compulim/web-speech-cognitive-services/issues/31), support reference grammars, in PR [#37](https://github.com/compulim/web-speech-cognitive-services/pull/37)
   - When creating the ponyfill, pass it as an array to `referenceGrammars` options
- Speech recognition: Fix [#27](https://github.com/compulim/web-speech-cognitive-services/issues/27), support custom speech, in PR [#41](https://github.com/compulim/web-speech-cognitive-services/pull/41)
   - Use option `speechRecognitionEndpointId`
- Speech synthesis: Fix [#28](https://github.com/compulim/web-speech-cognitive-services/issues/28) and [#62](https://github.com/compulim/web-speech-cognitive-services/issues/62), support custom voice font, in PR [#41](https://github.com/compulim/web-speech-cognitive-services/pull/41) and PR [#67](https://github.com/compulim/web-speech-cognitive-services/pull/67)
   - Use option `speechSynthesisDeploymentId`
   - Voice list is only fetch when using subscription key
- Speech synthesis: Fix [#48](https://github.com/compulim/web-speech-cognitive-services/issues/48), support output format through `outputFormat` option, in PR [#49](https://github.com/compulim/web-speech-cognitive-services/pull/49)
- `*`: Fix [#47](https://github.com/compulim/web-speech-cognitive-services/issues/47), add `enableTelemetry` option for disabling collecting telemetry data in Speech SDK, in PR [#51](https://github.com/compulim/web-speech-cognitive-services/pull/51) and PR [#66](https://github.com/compulim/web-speech/cognitive-services/pull/66)
- `*`: Fix [#53](https://github.com/compulim/web-speech-cognitive-services/issues/53), added ESLint, in PR [#54](https://github.com/compulim/web-speech-cognitive-services/pull/54)
- Speech synthesis: Fix [#39](https://github.com/compulim/web-speech-cognitive-services/issues/39), support SSML utterance, in PR [#57](https://github.com/compulim/web-speech-cognitive-services/pull/57)
- Speech recognition: Fix [#59](https://github.com/compulim/web-speech-cognitive-services/issues/59), support `stop()` function by finalizing partial speech, in PR [#60](https://github.com/compulim/web-speech-cognitive-services/pull/60)
- Fix [#67](https://github.com/compulim/web-speech-cognitive-services/issues/67), add warning when using subscription key instead of authorization token, in PR [#69](https://github.com/compulim/web-speech-cognitive-services/pull/69)
- Fix [#70](https://github.com/compulim/web-speech-cognitive-services/issues/70), fetch authorization token before every synthesis, in PR [#71](https://github.com/compulim/web-speech-cognitive-services/pull/71)

### Changed

- Bumped dependencies, in PR [#20](https://github.com/compulim/web-speech-cognitive-services/pull/20)
   - [@babel/cli@^7.5.5](https://www.npmjs.com/package/@babel/cli)
   - [@babel/core@^7.5.5](https://www.npmjs.com/package/@babel/core)
   - [@babel/plugin-proposal-object-rest-spread@^7.5.5](https://www.npmjs.com/package/@babel/plugin-proposal-object-rest-spread)
   - [@babel/plugin-transform-runtime@^7.5.5](https://www.npmjs.com/package/@babel/plugin-transform-runtime)
   - [@babel/preset-env@^7.5.5](https://www.npmjs.com/package/@babel/preset-env)
   - [@babel/runtime@^7.5.5](https://www.npmjs.com/package/@babel/runtime)
   - [babel-jest@^24.8.0](https://www.npmjs.com/package/babel-jest)
   - [babel-plugin-transform-inline-environment-variables@^0.4.3](https://www.npmjs.com/package/babel-plugin-transform-inline-environment-variables)
   - [jest@^24.8.0](https://www.npmjs.com/package/jest)
   - [memoize-one@^5.0.5](https://www.npmjs.com/package/memoize-one)
   - [rimraf@^2.6.3](https://www.npmjs.com/package/rimraf)
   - [simple-update-in@^2.1.0](https://www.npmjs.com/package/simple-update-in)
- Added version number as `<meta>` tag, in PR [#20](https://github.com/compulim/web-speech-cognitive-services/pull/20)
- Added bundle distribution thru https://unpkg.com/web-speech-cognitive-services@latest/umd/, in PR [#21](https://github.com/compulim/web-speech-cognitive-services/pull/21)
- Bumped to [microsoft-cognitiveservices-speech-sdk@1.6.0](https://www.npmjs.com/package/microsoft-cognitiveservices-speech-sdk), in PR [#22](https://github.com/compulim/web-speech-cognitive-services/pull/22)
- Fix [#55](https://github.com/compulim/web-speech-cognitive-services/issues/55) and [#63](https://github.com/compulim/web-speech-cognitive-services/issues/63). Moves to [WHATWG `EventTarget` interface](https://dom.spec.whatwg.org/#interface-eventtarget), in PR [#56](https://github.com/compulim/web-speech-cognitive-services/pulls/56) and PR [#64](https://github.com/compulim/web-speech-cognitive-services/pulls/64)
- Instead of including `event-target-shim@5.0.1`, we are adopting its source code, in PR [#72](https://github.com/compulim/web-speech-cognitive-services/pulls/72)
   - This is because the original package requires browser to support rest/spread operators

### Fixed

- Fix [#45](https://github.com/compulim/web-speech-cognitive-services/issues/45). Speech synthesize should emit "start" and "error" if the synthesized audio clip cannot be fetch over the network, in PR [#46](https://github.com/compulim/web-speech-cognitive-services/issues/46)

## [4.0.0] - 2018-12-10
### Added
- New playground for better debuggability
- Support of Speech Services SDK, with automated unit tests for speech recognition
   - See [`SPEC-RECOGNITION.md`](SPEC-RECOGNITION.md) and [`SPEC-SYNTHESIS.md`](SPEC-SYNTHESIS.md) for quirks
- Speech recognition: Support `stop` on Speech Services
- Speech synthesis: Support `pause` and `resume` (with `pause` and `resume` event)
- Speech synthesis: Support `speaking` property

### Changed
- Ponyfill are now constructed based on options (authorization token, region, and subscription key)
   - A new set of ponyfill will be created every time an option has changed

### Fixed
- Fix [#13](https://github.com/compulim/web-speech-cognitive-services/issues/13) Speech recognition: `SpeechRecognitionResult` should be iterable

## [3.0.0] - 2018-10-31
### Added
- Speech Synthesis: Will async fetch speech token instead of throwing exception

### Changed
- Use `@babel/runtime` and `@babel/plugin-tranform-runtime`, in favor of `babel-polyfill`
- Better error handling on `null` token
- Updated voice list from [https://docs.microsoft.com/en-us/azure/cognitive-services/speech-service/supported-languages](https://docs.microsoft.com/en-us/azure/cognitive-services/speech-service/supported-languages)
- Reliability around cancelling a playing utterance
   - Instead of shutting down the `AudioContext`, we will stop the `AudioBufferSourceNode` for a graceful stop
- Simplify speech token authorization
   - `recognition.fetchToken = async () => return await 'your subscription key';`
   - `recognition.fetchToken = createFetchTokenUsingSubscriptionKey('your subscription key');`
   - `fetchToken` will be called every time a token is required, implementor should cache the token as needed
- Bump to [`@babel/core@7.1.2`](https://npmjs.com/package/@babel/core/v/7.1.2) and [`jest@^23.6.0`](https://npmjs.com/package/jest/v/23.6.0)
- Bump to [`react-scripts@2.0.4`](https://npmjs.com/package/react-scripts/v/2.0.4)
- Publish `/packages/component/` instead of `/`
- Bump to [`event-as-promise@1.0.5`](https://npmjs.com/package/event-as-promise/v/1.0.5)

## [2.1.0] - 2018-07-09
### Added
- Speech priming via custom `SpeechGrammarList`

## [2.0.0] - 2018-07-09
### Added
- SpeechSynthesis polyfill with Cognitive Services

### Changed
- Removed `CognitiveServices` prefix
   - Renamed `CognitiveServicesSpeechGrammarList` to `SpeechGrammarList`
   - Renamed `CognitiveServicesSpeechRecognition` to `SpeechRecognition`
   - Removed default export, now must use `import { SpeechRecognition } from 'web-speech-cognitive-services';`
- Speech Recognition: changed speech token authorization
   - `recognition.speechToken = new SubscriptionKey('your subscription key');`

## [1.0.0] - 2018-06-29
### Added
- Initial release
- SpeechRecognition polyfill with Cognitive Services
